VTK: vtkAbstractTransform Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkAbstractTransform Class Referenceabstract

superclass for all geometric transformations More...

`#include <vtkAbstractTransform.h>`

Inheritance diagram for vtkAbstractTransform:
[legend]
Collaboration diagram for vtkAbstractTransform:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkAbstractTransform * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | TransformPoint (const float in[3], float out[3])
| Apply the transformation to a coordinate. More...
void | TransformPoint (const double in[3], double out[3])
| Apply the transformation to a double-precision coordinate. More...
double * | TransformPoint (double x, double y, double z)
| Apply the transformation to a double-precision coordinate. More...
double * | TransformPoint (const double point[3])
double * | TransformNormalAtPoint (const double point[3], const double normal[3])
double * | TransformVectorAtPoint (const double point[3], const double vector[3])
virtual void | TransformPoints (vtkPoints *inPts, vtkPoints *outPts)
| Apply the transformation to a series of points, and append the results to outPts. More...
virtual void | TransformPointsNormalsVectors (vtkPoints *inPts, vtkPoints *outPts, vtkDataArray *inNms, vtkDataArray *outNms, vtkDataArray *inVrs, vtkDataArray *outVrs, int nOptionalVectors=0, vtkDataArray **inVrsArr=nullptr, vtkDataArray **outVrsArr=nullptr)
| Apply the transformation to a combination of points, normals and vectors. More...
vtkAbstractTransform * | GetInverse ()
| Get the inverse of this transform. More...
void | SetInverse (vtkAbstractTransform *transform)
| Set a transformation that this transform will be the inverse of. More...
virtual void | Inverse ()=0
| Invert the transformation. More...
void | DeepCopy (vtkAbstractTransform *)
| Copy this transform from another of the same type. More...
void | Update ()
| Update the transform to account for any changes which have been made. More...
virtual vtkAbstractTransform * | MakeTransform ()=0
| Make another transform of the same type. More...
virtual int | CircuitCheck (vtkAbstractTransform *transform)
| Check for self-reference. More...
vtkMTimeType | GetMTime () override
| Override GetMTime necessary because of inverse transforms. More...
void | UnRegister (vtkObjectBase *O) override
| Needs a special UnRegister() implementation to avoid circular references. More...
float * | TransformFloatPoint (float x, float y, float z)
| Apply the transformation to an (x,y,z) coordinate. More...
float * | TransformFloatPoint (const float point[3])
| Apply the transformation to an (x,y,z) coordinate. More...
double * | TransformDoublePoint (double x, double y, double z)
| Apply the transformation to a double-precision (x,y,z) coordinate. More...
double * | TransformDoublePoint (const double point[3])
| Apply the transformation to a double-precision (x,y,z) coordinate. More...
void | TransformNormalAtPoint (const float point[3], const float in[3], float out[3])
| Apply the transformation to a normal at the specified vertex. More...
void | TransformNormalAtPoint (const double point[3], const double in[3], double out[3])
| Apply the transformation to a normal at the specified vertex. More...
double * | TransformDoubleNormalAtPoint (const double point[3], const double normal[3])
| Apply the transformation to a double-precision normal at the specified vertex. More...
float * | TransformFloatNormalAtPoint (const float point[3], const float normal[3])
| Apply the transformation to a single-precision normal at the specified vertex. More...
void | TransformVectorAtPoint (const float point[3], const float in[3], float out[3])
| Apply the transformation to a vector at the specified vertex. More...
void | TransformVectorAtPoint (const double point[3], const double in[3], double out[3])
| Apply the transformation to a vector at the specified vertex. More...
double * | TransformDoubleVectorAtPoint (const double point[3], const double vector[3])
| Apply the transformation to a double-precision vector at the specified vertex. More...
float * | TransformFloatVectorAtPoint (const float point[3], const float vector[3])
| Apply the transformation to a single-precision vector at the specified vertex. More...
virtual void | InternalTransformPoint (const float in[3], float out[3])=0
| This will calculate the transformation without calling Update. More...
virtual void | InternalTransformPoint (const double in[3], double out[3])=0
| This will calculate the transformation without calling Update. More...
virtual void | InternalTransformDerivative (const float in[3], float out[3], float derivative[3][3])=0
| This will transform a point and, at the same time, calculate a 3x3 Jacobian matrix that provides the partial derivatives of the transformation at that point. More...
virtual void | InternalTransformDerivative (const double in[3], double out[3], double derivative[3][3])=0
| This will transform a point and, at the same time, calculate a 3x3 Jacobian matrix that provides the partial derivatives of the transformation at that point. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkAbstractTransform ()
| ~vtkAbstractTransform () override
virtual void | InternalUpdate ()
| Perform any subclass-specific Update. More...
virtual void | InternalDeepCopy (vtkAbstractTransform *)
| Perform any subclass-specific DeepCopy. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
float | InternalFloatPoint [3]
double | InternalDoublePoint [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

superclass for all geometric transformations

vtkAbstractTransform is the superclass for all VTK geometric transformations. The VTK transform hierarchy is split into two major branches: warp transformations and homogeneous (including linear) transformations. The latter can be represented in terms of a 4x4 transformation matrix, the former cannot.

Transformations can be pipelined through two mechanisms:

1) GetInverse() returns the pipelined inverse of a transformation i.e. if you modify the original transform, any transform previously returned by the GetInverse() method will automatically update itself according to the change.

2) You can do pipelined concatenation of transformations through the vtkGeneralTransform class, the vtkPerspectiveTransform class, or the vtkTransform class.

See also
  vtkGeneralTransform vtkWarpTransform vtkHomogeneousTransform vtkLinearTransform vtkIdentityTransform vtkTransformPolyDataFilter vtkTransformFilter vtkImageReslice vtkImplicitFunction

Definition at line 38 of file vtkAbstractTransform.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkAbstractTransform::Superclass

Definition at line 41 of file vtkAbstractTransform.h.

## Constructor & Destructor Documentation

## ◆ vtkAbstractTransform()

vtkAbstractTransform::vtkAbstractTransform | ( |  | ) |
| protected

## ◆ ~vtkAbstractTransform()

vtkAbstractTransform::~vtkAbstractTransform | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkAbstractTransform::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkAbstractTransform::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkGeoTransform, vtkGridTransform, vtkBSplineTransform, vtkWarpTransform, vtkTransform, vtkThinPlateSplineTransform, vtkSphericalTransform, vtkPerspectiveTransform, vtkMatrixToLinearTransform, vtkMatrixToHomogeneousTransform, vtkLinearTransform, vtkLandmarkTransform, vtkIdentityTransform, vtkHomogeneousTransform, vtkGeneralTransform, vtkCylindricalTransform, and vtkIterativeClosestPointTransform.

## ◆ SafeDownCast()

static vtkAbstractTransform* vtkAbstractTransform::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkAbstractTransform::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkGeoTransform, vtkGridTransform, vtkBSplineTransform, vtkWarpTransform, vtkTransform, vtkThinPlateSplineTransform, vtkSphericalTransform, vtkPerspectiveTransform, vtkMatrixToLinearTransform, vtkMatrixToHomogeneousTransform, vtkLinearTransform, vtkLandmarkTransform, vtkIdentityTransform, vtkHomogeneousTransform, vtkGeneralTransform, vtkCylindricalTransform, and vtkIterativeClosestPointTransform.

## ◆ NewInstance()

vtkAbstractTransform* vtkAbstractTransform::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkAbstractTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkGeoTransform, vtkGridTransform, vtkBSplineTransform, vtkWarpTransform, vtkTransform, vtkThinPlateSplineTransform, vtkSphericalTransform, vtkPerspectiveTransform, vtkMatrixToLinearTransform, vtkMatrixToHomogeneousTransform, vtkLinearTransform, vtkLandmarkTransform, vtkIdentityTransform, vtkHomogeneousTransform, vtkGeneralTransform, and vtkCylindricalTransform.

## ◆ TransformPoint() [1/4]

void vtkAbstractTransform::TransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) |  |
| inline

Apply the transformation to a coordinate.

You can use the same array to store both the input and output point.

Definition at line 48 of file vtkAbstractTransform.h.

## ◆ TransformPoint() [2/4]

void vtkAbstractTransform::TransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) |  |
| inline

Apply the transformation to a double-precision coordinate.

You can use the same array to store both the input and output point.

Definition at line 58 of file vtkAbstractTransform.h.

## ◆ TransformPoint() [3/4]

double* vtkAbstractTransform::TransformPoint | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |
| inline

Apply the transformation to a double-precision coordinate.

Use this if you are programming in Python or Java.

Definition at line 68 of file vtkAbstractTransform.h.

## ◆ TransformPoint() [4/4]

double* vtkAbstractTransform::TransformPoint | ( | const double | point[3] | ) |
| inline

Definition at line 72 of file vtkAbstractTransform.h.

## ◆ TransformFloatPoint() [1/2]

float* vtkAbstractTransform::TransformFloatPoint | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |
| inline

Apply the transformation to an (x,y,z) coordinate.

Use this if you are programming in Python or Java.

Definition at line 82 of file vtkAbstractTransform.h.

## ◆ TransformFloatPoint() [2/2]

float* vtkAbstractTransform::TransformFloatPoint | ( | const float | point[3] | ) |
| inline

Apply the transformation to an (x,y,z) coordinate.

Use this if you are programming in Python or Java.

Definition at line 90 of file vtkAbstractTransform.h.

## ◆ TransformDoublePoint() [1/2]

double* vtkAbstractTransform::TransformDoublePoint | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |
| inline

Apply the transformation to a double-precision (x,y,z) coordinate.

Use this if you are programming in Python or Java.

Definition at line 101 of file vtkAbstractTransform.h.

## ◆ TransformDoublePoint() [2/2]

double* vtkAbstractTransform::TransformDoublePoint | ( | const double | point[3] | ) |
| inline

Apply the transformation to a double-precision (x,y,z) coordinate.

Use this if you are programming in Python or Java.

Definition at line 109 of file vtkAbstractTransform.h.

## ◆ TransformNormalAtPoint() [1/3]

void vtkAbstractTransform::TransformNormalAtPoint | ( | const float | point[3],
|  | const float | in[3],
|  | float | out[3]
| ) |  |

Apply the transformation to a normal at the specified vertex.

If the transformation is a vtkLinearTransform, you can use TransformNormal() instead.

## ◆ TransformNormalAtPoint() [2/3]

void vtkAbstractTransform::TransformNormalAtPoint | ( | const double | point[3],
|  | const double | in[3],
|  | double | out[3]
| ) |  |

Apply the transformation to a normal at the specified vertex.

If the transformation is a vtkLinearTransform, you can use TransformNormal() instead.

## ◆ TransformNormalAtPoint() [3/3]

double* vtkAbstractTransform::TransformNormalAtPoint | ( | const double | point[3],
|  | const double | normal[3]
| ) |  |
| inline

Definition at line 125 of file vtkAbstractTransform.h.

## ◆ TransformDoubleNormalAtPoint()

double* vtkAbstractTransform::TransformDoubleNormalAtPoint | ( | const double | point[3],
|  | const double | normal[3]
| ) |  |
| inline

Apply the transformation to a double-precision normal at the specified vertex.

If the transformation is a vtkLinearTransform, you can use TransformDoubleNormal() instead.

Definition at line 137 of file vtkAbstractTransform.h.

## ◆ TransformFloatNormalAtPoint()

float* vtkAbstractTransform::TransformFloatNormalAtPoint | ( | const float | point[3],
|  | const float | normal[3]
| ) |  |
| inline

Apply the transformation to a single-precision normal at the specified vertex.

If the transformation is a vtkLinearTransform, you can use TransformFloatNormal() instead.

Definition at line 151 of file vtkAbstractTransform.h.

## ◆ TransformVectorAtPoint() [1/3]

void vtkAbstractTransform::TransformVectorAtPoint | ( | const float | point[3],
|  | const float | in[3],
|  | float | out[3]
| ) |  |

Apply the transformation to a vector at the specified vertex.

If the transformation is a vtkLinearTransform, you can use TransformVector() instead.

## ◆ TransformVectorAtPoint() [2/3]

void vtkAbstractTransform::TransformVectorAtPoint | ( | const double | point[3],
|  | const double | in[3],
|  | double | out[3]
| ) |  |

Apply the transformation to a vector at the specified vertex.

If the transformation is a vtkLinearTransform, you can use TransformVector() instead.

## ◆ TransformVectorAtPoint() [3/3]

double* vtkAbstractTransform::TransformVectorAtPoint | ( | const double | point[3],
|  | const double | vector[3]
| ) |  |
| inline

Definition at line 168 of file vtkAbstractTransform.h.

## ◆ TransformDoubleVectorAtPoint()

double* vtkAbstractTransform::TransformDoubleVectorAtPoint | ( | const double | point[3],
|  | const double | vector[3]
| ) |  |
| inline

Apply the transformation to a double-precision vector at the specified vertex.

If the transformation is a vtkLinearTransform, you can use TransformDoubleVector() instead.

Definition at line 180 of file vtkAbstractTransform.h.

## ◆ TransformFloatVectorAtPoint()

float* vtkAbstractTransform::TransformFloatVectorAtPoint | ( | const float | point[3],
|  | const float | vector[3]
| ) |  |
| inline

Apply the transformation to a single-precision vector at the specified vertex.

If the transformation is a vtkLinearTransform, you can use TransformFloatVector() instead.

Definition at line 194 of file vtkAbstractTransform.h.

## ◆ TransformPoints()

virtual void vtkAbstractTransform::TransformPoints | ( | vtkPoints * | inPts,
|  | vtkPoints * | outPts
| ) |  |
| virtual

Apply the transformation to a series of points, and append the results to outPts.

Reimplemented in vtkGeoTransform, vtkLinearTransform, vtkIdentityTransform, and vtkHomogeneousTransform.

## ◆ TransformPointsNormalsVectors()

virtual void vtkAbstractTransform::TransformPointsNormalsVectors | ( | vtkPoints * | inPts,
|  | vtkPoints * | outPts,
|  | vtkDataArray * | inNms,
|  | vtkDataArray * | outNms,
|  | vtkDataArray * | inVrs,
|  | vtkDataArray * | outVrs,
|  | int | nOptionalVectors = `0`,
|  | vtkDataArray ** | inVrsArr = `nullptr`,
|  | vtkDataArray ** | outVrsArr = `nullptr`
| ) |  |
| virtual

Apply the transformation to a combination of points, normals and vectors.

Reimplemented in vtkLinearTransform, vtkIdentityTransform, and vtkHomogeneousTransform.

## ◆ GetInverse()

vtkAbstractTransform* vtkAbstractTransform::GetInverse | ( |  | ) |

Get the inverse of this transform.

If you modify this transform, the returned inverse transform will automatically update. If you want the inverse of a vtkTransform, you might want to use GetLinearInverse() instead which will type cast the result from vtkAbstractTransform to vtkLinearTransform.

## ◆ SetInverse()

void vtkAbstractTransform::SetInverse | ( | vtkAbstractTransform * | transform | ) |

Set a transformation that this transform will be the inverse of.

This transform will automatically update to agree with the inverse transform that you set.

## ◆ Inverse()

virtual void vtkAbstractTransform::Inverse | ( |  | ) |
| pure virtual

Invert the transformation.

Implemented in vtkGeoTransform, vtkWarpTransform, vtkTransform, vtkPerspectiveTransform, vtkMatrixToLinearTransform, vtkMatrixToHomogeneousTransform, vtkLandmarkTransform, vtkIdentityTransform, vtkGeneralTransform, and vtkIterativeClosestPointTransform.

## ◆ DeepCopy()

void vtkAbstractTransform::DeepCopy | ( | vtkAbstractTransform * |  | ) |

Copy this transform from another of the same type.

## ◆ Update()

void vtkAbstractTransform::Update | ( |  | ) |

Update the transform to account for any changes which have been made.

You do not have to call this method yourself, it is called automatically whenever the transform needs an update.

## ◆ InternalTransformPoint() [1/2]

virtual void vtkAbstractTransform::InternalTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) |  |
| pure virtual

This will calculate the transformation without calling Update.

Meant for use only within other VTK classes.

Implemented in vtkGeoTransform, vtkWarpTransform, vtkLinearTransform, vtkIdentityTransform, vtkHomogeneousTransform, and vtkGeneralTransform.

## ◆ InternalTransformPoint() [2/2]

virtual void vtkAbstractTransform::InternalTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) |  |
| pure virtual

This will calculate the transformation without calling Update.

Meant for use only within other VTK classes.

Implemented in vtkGeoTransform, vtkWarpTransform, vtkLinearTransform, vtkIdentityTransform, vtkHomogeneousTransform, and vtkGeneralTransform.

## ◆ InternalTransformDerivative() [1/2]

virtual void vtkAbstractTransform::InternalTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) |  |
| pure virtual

This will transform a point and, at the same time, calculate a 3x3 Jacobian matrix that provides the partial derivatives of the transformation at that point.

This method does not call Update. Meant for use only within other VTK classes.

Implemented in vtkGeoTransform, vtkWarpTransform, vtkLinearTransform, vtkIdentityTransform, vtkHomogeneousTransform, and vtkGeneralTransform.

## ◆ InternalTransformDerivative() [2/2]

virtual void vtkAbstractTransform::InternalTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) |  |
| pure virtual

This will transform a point and, at the same time, calculate a 3x3 Jacobian matrix that provides the partial derivatives of the transformation at that point.

This method does not call Update. Meant for use only within other VTK classes.

Implemented in vtkGeoTransform, vtkWarpTransform, vtkLinearTransform, vtkIdentityTransform, vtkHomogeneousTransform, and vtkGeneralTransform.

## ◆ MakeTransform()

virtual vtkAbstractTransform* vtkAbstractTransform::MakeTransform | ( |  | ) |
| pure virtual

Make another transform of the same type.

Implemented in vtkGeoTransform, vtkGridTransform, vtkBSplineTransform, vtkTransform, vtkThinPlateSplineTransform, vtkSphericalTransform, vtkPerspectiveTransform, vtkMatrixToLinearTransform, vtkMatrixToHomogeneousTransform, vtkLandmarkTransform, vtkIdentityTransform, vtkGeneralTransform, vtkCylindricalTransform, and vtkIterativeClosestPointTransform.

## ◆ CircuitCheck()

virtual int vtkAbstractTransform::CircuitCheck | ( | vtkAbstractTransform * | transform | ) |
| virtual

Check for self-reference.

Will return true if concatenating with the specified transform, setting it to be our inverse, or setting it to be our input will create a circular reference. CircuitCheck is automatically called by SetInput(), SetInverse(), and Concatenate(vtkXTransform *). Avoid using this function, it is experimental.

Reimplemented in vtkTransform, vtkPerspectiveTransform, and vtkGeneralTransform.

## ◆ GetMTime()

vtkMTimeType vtkAbstractTransform::GetMTime | ( |  | ) |
| overridevirtual

Override GetMTime necessary because of inverse transforms.

Reimplemented from vtkObject.

Reimplemented in vtkGridTransform, vtkBSplineTransform, vtkTransform, vtkThinPlateSplineTransform, vtkPerspectiveTransform, vtkMatrixToLinearTransform, vtkMatrixToHomogeneousTransform, vtkLandmarkTransform, and vtkGeneralTransform.

## ◆ UnRegister()

void vtkAbstractTransform::UnRegister | ( | vtkObjectBase * | O | ) |
| overridevirtual

Needs a special UnRegister() implementation to avoid circular references.

Reimplemented from vtkObjectBase.

## ◆ InternalUpdate()

virtual void vtkAbstractTransform::InternalUpdate | ( |  | ) |
| inlineprotectedvirtual

Perform any subclass-specific Update.

Reimplemented in vtkGridTransform, vtkBSplineTransform, vtkTransform, vtkThinPlateSplineTransform, vtkPerspectiveTransform, vtkMatrixToLinearTransform, vtkMatrixToHomogeneousTransform, vtkLandmarkTransform, vtkGeneralTransform, and vtkIterativeClosestPointTransform.

Definition at line 305 of file vtkAbstractTransform.h.

## ◆ InternalDeepCopy()

virtual void vtkAbstractTransform::InternalDeepCopy | ( | vtkAbstractTransform * |  | ) |
| inlineprotectedvirtual

Perform any subclass-specific DeepCopy.

Reimplemented in vtkGridTransform, vtkBSplineTransform, vtkThinPlateSplineTransform, vtkSphericalTransform, vtkMatrixToLinearTransform, vtkMatrixToHomogeneousTransform, vtkLandmarkTransform, vtkHomogeneousTransform, vtkCylindricalTransform, vtkIterativeClosestPointTransform, vtkTransform, vtkPerspectiveTransform, vtkIdentityTransform, and vtkGeneralTransform.

Definition at line 310 of file vtkAbstractTransform.h.

## Member Data Documentation

## ◆ InternalFloatPoint

float vtkAbstractTransform::InternalFloatPoint[3]
| protected

Definition at line 312 of file vtkAbstractTransform.h.

## ◆ InternalDoublePoint

double vtkAbstractTransform::InternalDoublePoint[3]
| protected

Definition at line 313 of file vtkAbstractTransform.h.

The documentation for this class was generated from the following file:

- Common/Transforms/vtkAbstractTransform.h